> For a complete page index, fetch https://developer.close.com/llms.txt # Updating a Custom Activity instance PUT https://api.close.com/api/v1/activity/custom/{id}/ Content-Type: application/json A Custom Activity can be updated to add, change or remove any Custom Fields and to change the status between "draft" and "published". A Custom Activity can be pinned or unpinned by setting the `pinned` field to `true` or `false` when creating or updating a Custom Activity. Custom Fields appear in the format: `custom.{custom_field_id}`. See [Custom Fields](https://developer.close.com/api/resources/custom-fields/custom-fields-activity). Reference: https://developer.close.com/api/resources/activities/custom-activities/update ## Authentication - `Authorization` header (basic auth, required) — Use your API key as the username and leave the password empty. - `Authorization` header (bearer token, required) — Bearer authentication of the form `Bearer `, where token is your auth token. ## Request ### Path parameters - `id` (string, required) ### Body (application/json) This endpoint expects an UpdateCustomActivity. - `activity_at` (datetime, optional, nullable) - `contact_id` (string, optional, nullable) - `pinned` (boolean, optional, nullable) - `status` (enum, optional) - Allowed values: `draft`, `published` ## Response ### 200 Successful response - `_type` (string, required) - `activity_at` (datetime, required, nullable) - `contact_id` (string, required, nullable) - `created_by` (string, required, nullable) - `custom_activity_type_id` (string, required) - `date_created` (datetime, required) - `date_updated` (datetime, required) - `id` (string, required) - `last_published_at` (datetime, required, nullable) - `lead_id` (string, required, nullable) - `mentions` (list of string, required) - `mentions_updated_at` (datetime, required, nullable) - `organization_id` (string, required) - `pinned` (boolean, required) - `pinned_at` (datetime, required, nullable) - `source` (enum, required, nullable) - Allowed values: `ui`, `api`, `import`, `clipper`, `email`, `suggestion`, `segment-integration`, `customerio-integration`, `calendly-integration`, `ai`, `whatsapp`, `webform` - `status` (enum, required) - Allowed values: `draft`, `published` - `updated_by` (string, required, nullable) - `user_id` (string, required, nullable) - `users` (list of string, required) - `comment_summary` (CommentSummary, optional, nullable) - `created_by_name` (string, optional, nullable) - `updated_by_name` (string, optional, nullable) - `user_name` (string, optional, nullable) ## Errors ### 400 Bad Request Error Bad request - `any` ### 401 Unauthorized Error Unauthorized - `any` ### 404 Not Found Error Not found - `any` ## Types ### CommentSummary - `comment_count` (integer, required) - `thread_id` (string, required) ## Examples **Request** ```json { "pinned": true, "status": "published", "custom.cf_UpyNBvr6Rw8UBHh7zRboL3PYhbOVJl3XvwgPm3jg64S": "thedarknight@close.com", "custom.cf_cSh3fWT3rEJ1BFSezme2YAG6bPrZV5wUWKKrW4iN19g": null } ``` **Response** ```json { "_type": "CustomActivity", "activity_at": "2020-08-04T16:45:35.367000+00:00", "contact_id": null, "created_by": "user_Ova4RGFG7pztSeJiiMFdN7O2MFl71nD0uGO3bIOo4Wk", "custom_activity_type_id": "actitype_1h5m6uHM9BZOpwVhyRJb4Y", "date_created": "2020-08-04T16:45:35.367000+00:00", "date_updated": "2020-08-04T17:37:56.439000+00:00", "id": "acti_5J7mimiIKB1tQ3gVduP0c4UhXbNj5ptMLteAWRJu7Sf", "last_published_at": "2020-08-04T16:45:35.367000+00:00", "lead_id": "lead_hwnL36A2iEMSLIlmGhsdrcmOJzTUzqEHwr66wrA1K2T", "mentions": [], "mentions_updated_at": null, "organization_id": "orga_RbREgmiiwcr1w2b4cOnCMQaQPSIFxMqAD2Dh243uxcH", "pinned": true, "pinned_at": "2020-08-04T17:37:56.439000+00:00", "source": "ui", "status": "published", "updated_by": "user_Ova4RGFG7pztSeJiiMFdN7O2MFl71nD0uGO3bIOo4Wk", "user_id": "user_Ova4RGFG7pztSeJiiMFdN7O2MFl71nD0uGO3bIOo4Wk", "users": [], "created_by_name": "Bruce Wayne", "updated_by_name": "Bruce Wayne", "user_name": "Bruce Wayne", "custom.cf_UpyNBvr6Rw8UBHh7zRboL3PYhbOVJl3XvwgPm3jg64S": "thedarknight@close.com" } ``` **SDK Code** ```python activities.custom_activities_update_example import requests url = "https://api.close.com/api/v1/activity/custom/id/" payload = { "pinned": True, "status": "published", "custom.cf_UpyNBvr6Rw8UBHh7zRboL3PYhbOVJl3XvwgPm3jg64S": "thedarknight@close.com", "custom.cf_cSh3fWT3rEJ1BFSezme2YAG6bPrZV5wUWKKrW4iN19g": None } headers = { "Content-Type": "application/json" } response = requests.put(url, json=payload, headers=headers, auth=("", "")) print(response.json()) ``` ```javascript activities.custom_activities_update_example const url = 'https://api.close.com/api/v1/activity/custom/id/'; const credentials = btoa(":"); const options = { method: 'PUT', headers: {Authorization: `Basic ${credentials}`, 'Content-Type': 'application/json'}, body: '{"pinned":true,"status":"published","custom.cf_UpyNBvr6Rw8UBHh7zRboL3PYhbOVJl3XvwgPm3jg64S":"thedarknight@close.com","custom.cf_cSh3fWT3rEJ1BFSezme2YAG6bPrZV5wUWKKrW4iN19g":null}' }; try { const response = await fetch(url, options); const data = await response.json(); console.log(data); } catch (error) { console.error(error); } ``` ```go activities.custom_activities_update_example package main import ( "fmt" "strings" "net/http" "io" ) func main() { url := "https://api.close.com/api/v1/activity/custom/id/" payload := strings.NewReader("{\n \"pinned\": true,\n \"status\": \"published\",\n \"custom.cf_UpyNBvr6Rw8UBHh7zRboL3PYhbOVJl3XvwgPm3jg64S\": \"thedarknight@close.com\",\n \"custom.cf_cSh3fWT3rEJ1BFSezme2YAG6bPrZV5wUWKKrW4iN19g\": null\n}") req, _ := http.NewRequest("PUT", url, payload) req.SetBasicAuth("", "") req.Header.Add("Content-Type", "application/json") res, _ := http.DefaultClient.Do(req) defer res.Body.Close() body, _ := io.ReadAll(res.Body) fmt.Println(res) fmt.Println(string(body)) } ``` ```ruby activities.custom_activities_update_example require 'uri' require 'net/http' url = URI("https://api.close.com/api/v1/activity/custom/id/") http = Net::HTTP.new(url.host, url.port) http.use_ssl = true request = Net::HTTP::Put.new(url) request.basic_auth("", "") request["Content-Type"] = 'application/json' request.body = "{\n \"pinned\": true,\n \"status\": \"published\",\n \"custom.cf_UpyNBvr6Rw8UBHh7zRboL3PYhbOVJl3XvwgPm3jg64S\": \"thedarknight@close.com\",\n \"custom.cf_cSh3fWT3rEJ1BFSezme2YAG6bPrZV5wUWKKrW4iN19g\": null\n}" response = http.request(request) puts response.read_body ``` ```java activities.custom_activities_update_example import com.mashape.unirest.http.HttpResponse; import com.mashape.unirest.http.Unirest; HttpResponse response = Unirest.put("https://api.close.com/api/v1/activity/custom/id/") .basicAuth("", "") .header("Content-Type", "application/json") .body("{\n \"pinned\": true,\n \"status\": \"published\",\n \"custom.cf_UpyNBvr6Rw8UBHh7zRboL3PYhbOVJl3XvwgPm3jg64S\": \"thedarknight@close.com\",\n \"custom.cf_cSh3fWT3rEJ1BFSezme2YAG6bPrZV5wUWKKrW4iN19g\": null\n}") .asString(); ``` ```php activities.custom_activities_update_example request('PUT', 'https://api.close.com/api/v1/activity/custom/id/', [ 'body' => '{ "pinned": true, "status": "published", "custom.cf_UpyNBvr6Rw8UBHh7zRboL3PYhbOVJl3XvwgPm3jg64S": "thedarknight@close.com", "custom.cf_cSh3fWT3rEJ1BFSezme2YAG6bPrZV5wUWKKrW4iN19g": null }', 'headers' => [ 'Content-Type' => 'application/json', ], 'auth' => ['', ''], ]); echo $response->getBody(); ``` ```csharp activities.custom_activities_update_example using RestSharp; using RestSharp.Authenticators; var client = new RestClient("https://api.close.com/api/v1/activity/custom/id/"); client.Authenticator = new HttpBasicAuthenticator("", ""); var request = new RestRequest(Method.PUT); request.AddHeader("Content-Type", "application/json"); request.AddParameter("application/json", "{\n \"pinned\": true,\n \"status\": \"published\",\n \"custom.cf_UpyNBvr6Rw8UBHh7zRboL3PYhbOVJl3XvwgPm3jg64S\": \"thedarknight@close.com\",\n \"custom.cf_cSh3fWT3rEJ1BFSezme2YAG6bPrZV5wUWKKrW4iN19g\": null\n}", ParameterType.RequestBody); IRestResponse response = client.Execute(request); ```